/* edit-window-private.h
 *
 * Copyright 2023 Jonathan Blandford
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#pragma once

#include <adwaita.h>
#include "edit-state.h"
#include "edit-window.h"
#include "puzzle-stack.h"


G_BEGIN_DECLS


struct _EditWindow
{
  AdwApplicationWindow parent_instance;

  PuzzleStack *puzzle_stack;
  gulong changed_id;
  gchar *uri;

  PuzzleStackStage stage;

  EditState *edit_state;

  GtkWidget *modified_label;
  GtkWidget *subtitle_label;
  GtkWidget *autofill_button;
  GtkWidget *edit_menu_button;
  GtkWidget *dock;
  GtkWidget *center_frame;
  GtkWidget *main_stack;
  GtkWidget *word_list_frame;
  GtkWidget *tool_frame;

  /* Grid */
  GtkWidget *edit_grid;
  GtkWidget *symmetry_widget;
  GtkWidget *bars_widget;
  GtkWidget *shapebg_widget;
  GtkWidget *word_list_widget;

  /* Clues */
  GtkWidget *edit_clues;
  GtkWidget *clue_details_widget;
  GtkWidget *clue_list_widget;
  GtkWidget *clue_info_widget;

  /* Metadata */
  GtkWidget *edit_metadata;
};


void _edit_window_class_actions_init  (GtkWidgetClass        *widget_class);
void _edit_window_class_controls_init (GtkWidgetClass        *widget_class);
void _edit_window_puzzle_changed_cb   (EditWindow            *self,
                                       gboolean               new_frame,
                                       PuzzleStackChangeType  change_type,
                                       PuzzleStack           *puzzle_stack);


G_END_DECLS
